		ORG		0xc200

PEKON	EQU		0x00280000
DSKCAC	EQU		0x00100000
DSKCAC0	EQU		0x00008000

CYLS	EQU		0x0ff0
LEDS	EQU		0x0ff1

		MOV		AL,0x13
		MOV		AH,0x00
		INT		0x10
		MOV		AH,0x02
		INT		0x16
		MOV		[LEDS],AL

		MOV		AL,0xff
		OUT		0x21,AL
		NOP
		OUT		0xa1,AL
		CLI

		CALL	kbdWout
		MOV		AL,0xd1
		OUT		0x64,AL
		CALL	kbdWout
		MOV		AL,0xdf
		OUT		0x60,AL
		CALL	kbdWout

[INSTRSET "i486p"]
		LGDT	[gdtr0]
		MOV		EAX,CR0
		AND		EAX,0x7fffffff
		OR		EAX,0x00000001
		MOV		CR0,EAX
		JMP		plflash
plflash:
		MOV		AX,1*8
		MOV		DS,AX
		MOV		ES,AX
		MOV		FS,AX
		MOV		GS,AX
		MOV		SS,AX

		MOV		ESI,pekon
		MOV		EDI,PEKON
		MOV		ECX,512*1024/4
		CALL	memcpy

		MOV		ESI,0x7c00
		MOV		EDI,DSKCAC
		MOV		ECX,512/4
		CALL	memcpy

		MOV		ESI,DSKCAC0+512
		MOV		EDI,DSKCAC+512
		MOV		ECX,0
		MOV		CL,BYTE [CYLS]
		IMUL	ECX,512*18*2/4
		SUB		ECX,512/4
		CALL	memcpy

		MOV		EBX,PEKON
		MOV		ECX,[EBX+16]
		ADD		ECX,3
		SHR		ECX,2
		JZ		skip
		MOV		ESI,[EBX+20]
		ADD		ESI,EBX
		MOV		EDI,[EBX+12]
		CALL	memcpy
skip:
		MOV		ESP,[EBX+12]
		JMP		DWORD 2*8:0x0000001b

kbdWout:
		IN		AL,0x64
		AND		AL,0x02
		IN		AL,0x60
		JNZ		kbdWout
		RET

memcpy:
		MOV		EAX,[ESI]
		ADD		ESI,4
		MOV		[EDI],EAX
		ADD		EDI,4
		SUB		ECX,1
		JNZ		memcpy
		RET

		ALIGNB	8
gdt0:
		RESB	8
		DW		0xffff,0x0000,0x9200,0x00cf	; 32bit R/W
		DW		0xffff,0x0000,0x9a28,0x0047	; 32bit R/X
		DW		0
gdtr0:
		DW		8*3-1
		DD		gdt0
		ALIGNB	8
pekon:
