[FORMAT "WCOFF"]
[BITS 32]
[INSTRSET "i486p"]
[FILE "low.nas"]
		GLOBAL	_hlt,_cli,_sti,_stihlt,_in8
		GLOBAL	_out8,_eflagsLoad,_eflagsStore,_gdtrLoad,_idtrLoad
		GLOBAL	_int21Asm,_int2cAsm,_cr0Load,_cr0Store,_memTest0
		EXTERN	_int21,_int2c

[SECTION .text]
_hlt:
		HLT
		RET

_cli:
		CLI
		RET

_sti:
		STI
		RET

_stihlt:
		STI
		HLT
		RET

_in8:
		MOV		EDX,[ESP+4]
		MOV		EAX,0
		IN		AL,DX
		RET

_out8:
		MOV		EDX,[ESP+4]
		MOV		AL,[ESP+8]
		OUT		DX,AL
		RET

_eflagsLoad:
		PUSHFD
		POP		EAX
		RET

_eflagsStore:
		MOV		EAX,[ESP+4]
		PUSH	EAX
		POPFD
		RET

_gdtrLoad:
		MOV		AX,[ESP+4]
		MOV		[ESP+6],AX
		LGDT	[ESP+6]
		RET

_idtrLoad:
		MOV		AX,[ESP+4]
		MOV		[ESP+6],AX
		LIDT	[ESP+6]
		RET

_int21Asm:
		PUSH	ES
		PUSH	DS
		PUSHAD
		MOV		EAX,ESP
		PUSH	EAX
		MOV		AX,SS
		MOV		DS,AX
		MOV		ES,AX
		CALL	_int21
		POP		EAX
		POPAD
		POP		DS
		POP		ES
		IRETD

_int2cAsm:
		PUSH	ES
		PUSH	DS
		PUSHAD
		MOV		EAX,ESP
		PUSH	EAX
		MOV		AX,SS
		MOV		DS,AX
		MOV		ES,AX
		CALL	_int2c
		POP		EAX
		POPAD
		POP		DS
		POP		ES
		IRETD

_cr0Load:
		MOV		EAX,CR0
		RET

_cr0Store:
		MOV		EAX,[ESP+4]
		MOV		CR0,EAX
		RET

_memTest0:
		PUSH	EDI
		PUSH	ESI
		PUSH	EBX
		MOV		ESI,0xaa55aa55
		MOV		EDI,0x55aa55aa
		MOV		EAX,[ESP+16]
mtloop:
		MOV		EBX,EAX
		ADD		EBX,0x0ffc
		MOV		EDX,[EBX]
		MOV		[EBX],ESI
		XOR		DWORD [EBX],0xffffffff
		CMP		EDI,[EBX]
		JNE		mtfin
		XOR		DWORD [EBX],0xffffffff
		CMP		ESI,[EBX]
		JNE		mtfin
		MOV		[EBX],EDX
		ADD		EAX,0x1000
		CMP		EAX,[ESP+20]
		JBE		mtloop
		POP		EBX
		POP		ESI
		POP		EDI
		RET
mtfin:
		MOV		[EBX],EDX
		POP		EBX
		POP		ESI
		POP		EDI
		RET
