#include "pekon.h"
#include <stdio.h>

void wintest(struct sheet *sht, int sx, int sy, char *s, int act);
void cursortest(struct sheet *sht);
void pekontest(struct sheet *sht, int act);

void HariMain(void)
{
	struct fifo fifo;
	struct mouse mouse;
	struct memory *mem = (struct memory *) 0x003c0000;
	unsigned int memsize;
	struct sheet *shtBack, *shtMouse, *shtWin;
	unsigned char *bufBack, bufMouse[176], *bufWin;
	int fifobuf[64], mx, my, i;
	char s[16];
	gdtidtInit();
	picInit();
	sti();
	fifoInit(&fifo, fifobuf, 64);
	keyInit(&fifo);
	mouseEnable(&mouse);
	out8(0x0021, 0xf9);		/* 11111001 PIC1, Keyboard */
	out8(0x00a1, 0xef);		/* 11101111 Mouse */
	memsize = memTest(0x00400000, 0xbfffffff);
	memInit(mem);
	memFree(mem, 0x00001000, 0x0009e000);
	memFree(mem, 0x00400000, memsize - 0x00400000);

	paletteInit();
	shtInit(mem);
	shtBack = shtAlloc();
	bufBack = (unsigned char *) memAlloc(mem, 320 * 200);
	shtSet(shtBack, bufBack, 320, 200, -1);
	boxfill(shtBack, _FFFFFF, 0, 0, 319, 199);

	shtMouse = shtAlloc();
	shtSet(shtMouse, bufMouse, 11, 16, 99);
	mx = (320 - 11) / 2;
	my = (200 - 16) / 2;
	cursortest(shtMouse);

	shtWin = shtAlloc();
	bufWin = (unsigned char *) memAlloc(mem, (4 + 22 + 8 * 12) * (22 + 18 * 7));
	shtSet(shtWin, bufWin, 4 + 22 + 8 * 12, 22 + 18 * 7, -1);
	pekontest(shtWin, 1);

	sprintf(s, "lcr(%3d,%3d)", mx, my);
	putfonts(shtBack, _000000, 24, 0, s);
	sprintf(s, "%4d/%4dMB", memTotal(mem) / (1024 * 1024), memsize / (1024 * 1024));
	putfonts(shtBack, _000000, 0, 16, s);

	shtSlide( shtBack,  0,  0);
	shtSlide(shtMouse, mx, my);
	shtSlide(  shtWin,  8, 40);
	shtUpdown( shtBack, 0);
	shtUpdown(  shtWin, 1);
	shtUpdown(shtMouse, 2);

	for (;;) {
		cli();
		if (fifoStat(&fifo) == 0) {
			stihlt();
		} else {
			i = fifoGet(&fifo);
			sti();
			if (256 <= i && i <= 511) {
				i -= 256;
				sprintf(s, "%02X", i);
				boxfill(shtBack, _FFFFFF, 0, 0, 15, 15);
				putfonts(shtBack, _000000, 0, 0, s);
				shtRefresh();
			} else if (512 <= i && i <= 767) {
				if (mouseDecode(&mouse, i - 512) != 0) {
					mx += mouse.x;
					my += mouse.y;
					if (mx < 0) {
						mx = 0;
					} else if (mx > 320 - 11) {
						mx = 320 - 11;
					}
					if (my < 0) {
						my = 0;
					} else if (my > 200 - 16) {
						my = 200 - 16;
					}
					sprintf(s, "lcr(%3d,%3d)", mx, my);
					if ((mouse.btn & 0x01) != 0) {
						s[0] = 'L';
					}
					if ((mouse.btn & 0x02) != 0) {
						s[2] = 'R';
					}
					if ((mouse.btn & 0x04) != 0) {
						s[1] = 'C';
					}
					boxfill(shtBack, _FFFFFF, 24, 0, 24 + 8 * 12 - 1, 15);
					putfonts(shtBack, _000000, 24, 0, s);
					shtSlide(shtMouse, mx, my);
				}
			}
		}
	}
}

void wintest(struct sheet *sht, int sx, int sy, char *s, int act)
{
	char c;
	if (act != 0) {
		c = _000000;
	} else {
		c = _848484;
	}
	boxframe(sht, _000000, 0, 0, sx - 1, sy - 1);
	boxfill(sht, _FFFFFF, 1, 1, sx - 2, sy - 2);
	putfonts(sht, c, 24, 2, s);
	boxfill(sht, _000000, 0, 20, sx - 1, 20);
	boxframe(sht, c, 4, 4, 16, 16);
}

void cursortest(struct sheet *sht)
{
	static char cursor[16][11] = {
		"*          ",
		"**         ",
		"***        ",
		"****       ",
		"*****      ",
		"******     ",
		"*******    ",
		"********   ",
		"*********  ",
		"********** ",
		"***********",
		"*****      ",
		"****       ",
		"***        ",
		"**         ",
		"*          "
	};
	int x, y;
	for (y = 0; y < 16; y++) {
		for (x = 0; x < 11; x++) {
			if (cursor[y][x] == '*') {
				sht->buf[y * sht->sizex + x] = _000000;
			} else {
				sht->buf[y * sht->sizex + x] = sht->cinv;
			}
		}
	}
	return;
}

#define BARSIZE(X, Y)		(18 * 7 - 1) * (X * 100) / Y / 100

void pekontest(struct sheet *sht, int act)
{
	wintest(sht, 4 + 22 + 8 * 12, 22 + 18 * 7, "pekon", act);
	boxfill(sht, _000000, 4 + 8 * 12, 20, 4 + 8 * 12, 22 + 18 * 7 - 1);
	boxframe(sht, _000000, 5 + 8 * 12, 21, 4 + 22 + 8 * 12 - 2, 21 + BARSIZE(7, 9));
	putfonts(sht, _000000, 2, 22, "PEKON   .SYS");
	putfonts(sht, _000000, 2, 40, "README  .TXT");
	putfonts(sht, _000000, 2, 58, "PAD     .HRB");
	putfonts(sht, _000000, 2, 76, "VIEW    .HRB");
	putfonts(sht, _000000, 2, 94, "BBALL   .HRB");
	putfonts(sht, _000000, 2, 112, "CALC    .HRB");
	putfonts(sht, _000000, 2, 130, "PLAY    .HRB");
	return;
}
