/* low.nas */
void hlt(void);
void cli(void);
void sti(void);
void stihlt(void);
int in8(int port);
void out8(int port, int data);
int eflagsLoad(void);
void eflagsStore(int eflags);
void gdtrLoad(int limit, int addr);
void idtrLoad(int limit, int addr);
void int21Asm(void);
void int2cAsm(void);
int cr0Load(void);
void cr0Store(int cr0);
unsigned int memTest0(unsigned int start, unsigned int end);
/* memory.c */
#define MEMORIES	0x4090
struct freeinfo {
	unsigned int addr, size;
};
struct memory {
	int frees;
	struct freeinfo free[MEMORIES];
};
unsigned int memTest(unsigned int start, unsigned int end);
void memInit(struct memory *mem);
unsigned int memTotal(struct memory *mem);
unsigned int memAlloc(struct memory *mem, unsigned int size);
void memFree(struct memory *mem, unsigned int addr, unsigned int size);
/* graphic.c */
#define SHEETS		64
struct sheet {
	unsigned char *buf;
	int x, y, sizex, sizey, cinv, height, flag;
};
struct sheets {
	int top;
	struct sheet *sht[SHEETS], sheet[SHEETS];
};
#define _000000		0
#define _FF0000		1
#define _00FF00		2
#define _FFFF00		3
#define _0000FF		4
#define _FF00FF		5
#define _00FFFF		6
#define _FFFFFF		7
#define _C6C6C6		8
#define _840000		9
#define _008400		10
#define _848400		11
#define _000084		12
#define _840084		13
#define _008484		14
#define _848484		15
#define SHTUSE		1
void paletteInit(void);
void paletteSet(unsigned char *rgb, int start, int end);
void shtInit(struct memory *mem);
struct sheet *shtAlloc(void);
void shtSet(struct sheet *sht, unsigned char *buf, int sizex, int sizey, int cinv);
void shtUpdown(struct sheet *sht, int height);
void shtRefresh(void);
void shtSlide(struct sheet *sht, int x, int y);
void shtFree(struct sheet *sht);
void boxfill(struct sheet *sht, int c, int x0, int y0, int x1, int y1);
void putfont(struct sheet *sht, int c, int x, int y, char *font);
void putfonts(struct sheet *sht, int c, int x, int y, unsigned char *s);
void boxframe(struct sheet *sht, int c, int x0, int y0, int x1, int y1);
/* fifo.c */
struct fifo {
	int *buf, size, free, rp, wp;
};
void fifoInit(struct fifo *fifo, int *buf, int size);
void fifoPut(struct fifo *fifo, int data);
int fifoGet(struct fifo *fifo);
int fifoStat(struct fifo *fifo);
/* pekon.h */
struct segdesc {
	short limitLow, baseLow;
	char baseMid, ar;
	char limitHigh, baseHigh;
};
struct gatedesc {
	short offsetLow, sel;
	char dwCount, ar;
	short offsetHigh;
};
struct mouse {
	unsigned char buf[3], phase;
	int x, y, btn;
};
#define PEKONADDR	0x00280000
#define PEKONLIMIT	0x0007ffff
#define SEGRW		0x4092
#define SEGRX		0x409a
#define GATEINT		0x008e
void gdtidtInit(void);
void segdescSet(struct segdesc *sd, unsigned int limit, unsigned int base, int ar);
void gatedescSet(struct gatedesc *gd, unsigned int offset, int sel, int ar);
void picInit(void);
void int21(int *esp);
void int2c(int *esp);
void kbdReady(void);
void keyInit(struct fifo *fifo);
void mouseEnable(struct mouse *mouse);
int mouseDecode(struct mouse *mouse, unsigned char data);
